Subject: Re: bug#50983: 28.0.50; [REGRESSION, BUG] Display bugs with uncommon characters

From: Rudi C <[email-masked]>
Date: Sun, 3 Oct 2021 10:17:21 +0330

> The site which you use to post the files is problematic: its
certificate is expired or invalid.

I use caddy to automatically manage its certificates, and I don't get any
cert errors myself. Can you be more specific? Perhaps you need newer
versions of wget?

https://www.ssllabs.com/ssltest/analyze.html?d=files.lilf.ir also says
everything is okay.

> This could be specific to macOS

I tested `bug.txt` via SSH on an Ubuntu server with emacs 27.2, and it was
no different:
https://files.lilf.ir/tmp/tmp.mZxt5Pilap.png

Testing it with other terminal apps, none of the bugs occur with
`terminal.app`.

The RTL is all wrong on `terminal.app` though (
https://files.lilf.ir/tmp/tmp.1UjK8TYGoG.png)
, but I guess it's unrelated. Alacritty doesn't show the bug, and it also
doesn't mess up the RTL shaping.

However, the bug is probably an interaction between both emacs and the
terminal app Kitty, as `vim` does not have this problem. Interestingly,
neovim does. (This is true for both of the bugs; vim doesn't have them,
emacs and nvim do, and only on Kitty.)

BTW, I tested using `command kitty --config=/dev/null`, so the bug did not
have anything with my Kitty config. (A screenshot in unconfigured Kitty:
https://files.lilf.ir/tmp/tmp.UcEXWQkTwn.png)

If you think the issue is to be upstreamed to Kitty, can you open an issue
on their Github? (https://github.com/kovidgoyal/kitty/issues)

Thanks.

On Sun, Oct 3, 2021 at 9:21 AM Eli Zaretskii <[email-masked]> wrote:

> > From: Rudi C <[email-masked]>
> > Date: Sun, 3 Oct 2021 02:20:24 +0330
> >
> > I have two display bugs to report, one a regression that is not present
> in emacs 27. I start with this
> > regression.
> >
> > 1. `curl https://files.lilf.ir/tmp/weird.txt > weird.txt`
> > 2. `emacs -Q -nw weird.txt`
> > 3. try editing the text, deleting characters, etc. The character display
> will get messed up.
> >
> > Here is a screenshot of emacs before editing the file:
> >
> > https://files.lilf.ir/tmp/tmp.kik6vbBw8S.png
> >
> > And here is a screenshot after I do `backspace a`:
> > https://files.lilf.ir/tmp/tmp.Twz5ZXVbR6.png
> >
> > I have tried this bug with emacs 27 (both myself and some other user on
> IRC), and it is not present there.
> >
> > The second bug:
> > 1. `curl https://files.lilf.ir/tmp/bug.txt > bug.txt`
> > 2. do `cat bug.txt` and note the output:
> > https://files.lilf.ir/tmp/tmp.HKfKc9PUds.png
> >
> > 3. `emacs -Q -nw bug.txt`
> > As you can see, emacs is displaying the file incorrectly:
> > https://files.lilf.ir/tmp/tmp.0yKbCbB80R.png
> >
> > In particular, the line `#+TITLE: sharif/contact info` is not displayed
> at all.
> >
> > I could reproduce this bug on both emacs 27 and 28.
>
> I'm unable to reproduce any of this on my system.  Both files display
> correctly, and the problems after deleting character and/or after
> displaying the file in a -nw session don't happen.
>
> This could be specific to macOS, where AFAIK the display is
> implemented slightly differently from the other platforms.  Or maybe
> something else is at work here.  For the -nw problems, this could
> perhaps be related to the terminal emulator you are using (just a
> guess, I have no real explanation how that could hide entire portions
> of the file's display).
>
> P.S. The site which you use to post the files is problematic: its
> certificate is expired or invalid, and at least on one of my systems
> wget said the TLS handshake failed, perhaps for the same reason.
>